
#ifndef MSAMPLE_H
#define MSAMPLE_H

#include "incs.h"
#include "nghds.h"
#include "sample.h"
#include "rans.h"


GLOBAL int list[NC][PT6];      /* list of states to be scored        */
GLOBAL int count[NC][NLOC];    /* number of steps on each component 
                                         and for each locus          */
GLOBAL double score[NC][NLOC][PT6];
                             /* ibd counts, each locus, each pattern */

extern int read_gen_dat(FILE *,int [NLOC][NOBS],int [NLOC][NOBS],int *);
extern void allocate(int,int);
extern void set_switches(int,int,int *,int *);
extern void read_segs (FILE *,int,int,int);
extern int list_switches (int,int *,int *); 
extern void set_chromosomes (int,double *,int,int *,double *, int);
extern int set_genes(int);
extern void invert_label(int,int,int *);
extern int index_ibd(int,int,int,int *,int *,int *,FILE *);
extern void get_genes(int,int,int *,int *,int *);
extern int score_ibd(int,int *);
extern void gene_update(int,int,int);
extern void fwd_compute (int,double,double *,double *,double *);
extern int back_sample (int,int,int,double,double);
extern void realise(int,double *,int,int *,int *);
extern void trait_segs(int,int *,int *);
extern void next_marker_segs(int,int *,int *,int,int,double);
extern void set_genotypes (int,int,double *,int *,int *);
extern void print_segs(int);
extern void print_set_up(int);
extern void print_obs_genes(int,int ***);
extern double seg_pen2(int,int ***,double *,int,int,int *);
extern double new_pen(int,int *[2],int ***,double *,int,int,int *);
extern int pattern(int,int,int);
extern void binary(int,int,int *);
extern double prob_data(int,int,int,int);
extern int score_either(int,int,int);
extern int score_whichever(int,int,int,int);
extern void free_allocate_loci(void);
extern void free_allocate(void); 
extern void free_gen_dat(void);
extern void print_chromosome(int, int, int);

#endif

