#include "head.h"

double prob_data (alle0, alle1, ibd, j)
     int   alle0, alle1, ibd, j;

   /*  routine to give probability P(Y|Z), where Z is the IBD state of the 
   /*   affected descendant, and Y is the marker data on the decendant,
   /*   expressed as a vector of pairs of alleles (alle0, alle1), at each of
   /*   nloc loci.  qf will be the vector Qq[j] of allele frequencies for each 
   /*   locus.
    */
{
    double pop_prob (), inbred ();

    if (ibd == 0)
	return (pop_prob (alle0, alle1, Qq[j]));
    else
	return (inbred (alle0, alle1, Qq[j]));
}

double pop_prob (a1, a2, qf)
     int   a1, a2;
     double *qf;
{
    double cc;
    cc = qf[a1] * qf[a2];
    if (a1 != a2)
	cc += cc;
    return (cc);
}

double inbred (a1, a2, qf)
     int   a1, a2;
     double *qf;
{
    double cc;
    if (a1 == a2)
	cc = qf[a1];
    else
	cc = 0.0;
    return (cc);
}
