    
/*  functions are:
 *          findParents()
 *          checkParents()
 */

#include "pedchk.h"

/*----------------------------------------------------------------------*/
/* findParents():  looks for parents' records				*/

void findParents(void)
{
    PED_PTR pP = pPedDat;
    KEYS_PP ppK = ppKeyTab;
    KEYS_PP ppMa, ppPa;
    KEYS find;
    KEYS_PTRS pf = &find;
    int i;

    for (i = 0; i < nInd; ++i)		/* for each entry in key table	*/
    {
        pP = pPedDat + (*ppK)->ix - 1;

        				/* gets ma's name from ped data	*/
        if (find.nam = pP->namMa)
        {				/* finds ma's name in key table	*/
            ppMa = bsearch(&pf, ppKeyTab, 
                                nInd, sizeof(KEYS_PTRS), comparNam);
            if (ppMa)
                (*ppK)->ixMa = (*ppMa)->ix;  /* & stores ix in key table*/
        }

        			 	/* gets pa's name from ped data	*/
        if (find.nam = pP->namPa)		
        {				/* finds pa's name in key table	*/
            ppPa = bsearch(&pf, ppKeyTab, 
                               nInd, sizeof(KEYS_PTRS), comparNam);
            if (ppPa)
                (*ppK)->ixPa = (*ppPa)->ix;  /* & stores ix in key table*/
        }
        ++ppK;
    }
}

/*----------------------------------------------------------------------*/
/* checkParents():  checks for missing parents or not both specified    */

int checkParents(void)
{
    int ixPed;
    int ma, pa, i;
    int nFounders, nOneNamed, nBothMiss, nOneMiss;
    int namOneNamed, namBothMiss, namOneMiss;
    KEYS_PP ppK = ppKeyTab;
 
    nFounders = 0, nOneNamed = 0, nBothMiss = 0, nOneMiss = 0;

    for (i = 0; i < nInd; ++i)		/* for each entry in key table	*/
    {
        ixPed = (*ppK)->ix - 1;
        ma = (pPedDat + ixPed)->namMa;	/* gets ma's & pa's nam from	*/
        pa = (pPedDat + ixPed)->namPa;	/* ped data			*/

        if (ma == UNKNOWN && pa == UNKNOWN)   	   /* checks for founder*/
        {
            (*ppK)->founder = TRUE; 
            ++nFounders;
        }
        else if (ma == UNKNOWN || pa == UNKNOWN)   /* checks for only   */	
        {                                          /* one parent        */
            ++nOneNamed;
            if (nOneNamed == 1)
                namOneNamed = (pPedDat + ixPed)->nam;
        }
        else if (!(*ppK)->ixMa && !(*ppK)->ixPa)   /* checks for parents*/
        {                                          /* not in pedigree 	*/
            ++nBothMiss;
            if (nBothMiss == 1)
                namBothMiss = (pPedDat + ixPed)->nam;
        }
        else if (!(*ppK)->ixMa || !(*ppK)->ixPa)   /* checks for one    */
        {                                          /* not in pedigree 	*/
            ++nOneMiss;
            if (nOneMiss == 1)
                namOneMiss = (pPedDat + ixPed)->nam;
        }
        ++ppK;
    }
    fprintf(stdout, " Number of founders is %d\n\n", nFounders);
   
    if (nOneNamed)
    {
        if (nOneNamed == 1)
            give_err(ERC_1p1, "checkParents", namOneNamed);
        else
            give_err(ERC_1pr, "checkParents", nOneNamed,
                                                  namOneNamed);
        return !OK;
    }
    if (nBothMiss)
    {
        if (nBothMiss == 1)
            give_err(ERC_0p1, "checkParents", namBothMiss);
        else
            give_err(ERC_0pr, "checkParents", nBothMiss,
                                                  namBothMiss);
        return !OK;
    }
    if (nOneMiss)
    {
        if (nOneMiss == 1)
            give_err(ERC_0p1, "checkParents", namOneMiss);
        else
            give_err(ERC_0pr, "checkParents", nOneMiss,
                                                  namOneMiss);
        return !OK;
    }
    return OK;
}

