
# include "rans.h"

/* functions for managing seeds for MORGAN V2             
 * see source file rans.c for the random number generator used
 * 
 * functions are:	setSeeds()  
 * 			getSeeds()
 *			assgnSeeds()
 * 			writSeeds()
 */

void setSeeds(int seedTyp)
{
    uint32 *     pSeedC = NULL;
    uint32 *     pSeedT = NULL;
  
    switch (seedTyp)
    {
        case MARK:
            pSeedC = &MarkSeedC;
            pSeedT = &MarkSeedT;
            fprintf(stdout, " Hexadecimal marker seeds:");
            break;

        case TRAIT:
            pSeedC = &TraitSeedC;
            pSeedT = &TraitSeedT;
            fprintf(stdout, " Hexadecimal trait seeds:");
            break;

        case SAMPL:
            pSeedC = &SamplSeedC;
            pSeedT = &SamplSeedT;
            fprintf(stdout, " Hexadecimal sampler seeds:");
            break;

        default:
            ;
    }
   
    setsd(*pSeedC, *pSeedT);

    fprintf(stdout, "  %#x %#x\n\n", *pSeedC, *pSeedT);

    return;
}

void getSeeds(int seedTyp)
{
    uint32 *     pSeedC = NULL;
    uint32 *     pSeedT = NULL;
  
    switch (seedTyp)
    {
        case MARK:
            pSeedC = &MarkSeedC;
            pSeedT = &MarkSeedT;
            break;

        case TRAIT:
            pSeedC = &TraitSeedC;
            pSeedT = &TraitSeedT;
            break;

        case SAMPL:
            pSeedC = &SamplSeedC;
            pSeedT = &SamplSeedT;
            break;

        default:
            ;
    }

    getsd(pSeedC, pSeedT);

    return;
}

void assgnSeeds(void)
{
    if (!TraitSeedSet)
    {
        TraitSeedC = MarkSeedC;
        TraitSeedT = MarkSeedT;
    }

    return;
}

void writSeeds(FILE * oSeedF)
{
    if (MarkSeedsOut)
        fprintf(oSeedF, " set marker seeds %#x %#x\n", 
                        MarkSeedC, MarkSeedT);
    if (TraitSeedsOut)
        fprintf(oSeedF, " set trait seeds  %#x %#x\n", 
                        TraitSeedC, TraitSeedT);
    if (SamplSeedsOut)
        fprintf(oSeedF, " set sampler seeds  %#x %#x\n", 
                        SamplSeedC, SamplSeedT);
    return;
}
