/********************************************************************

 Program copied from autonew.c in Twoloc/Utahprogs/Autozyg directory,
 implementing the recursive routine for gene identity at two loci.

 This then determines the probabilities of each of the 2^k patterns of
 gene identity at k loci, in a single inbred individual.  -- assumed
 MARKOV IBD -- omit this part!! - use only 2-locus ibd computation.

 g4link rountine corrected, March 2000 -- EAT

 Rewritten so that it can now read in standard pedigree data used by
 other MORGAN 2.3 programs and also can use the same data structure 
 and kinship() function in the Nghd library.                               
                                                   Aug, 2000 -- Na Li

*********************************************************************/


/*********************************************************************
   Author     : Michael Na Li <nali@stat.washington.edu>
   Created    : Thu Aug 17 13:44:39 PDT 2000
   Modified   : $Date: 2000/10/27 23:10:47 $
   Version    : $Revision: 1.3 $
   CVS        : $Id: autolink.c,v 1.3 2000/10/27 23:10:47 nali Exp $
**********************************************************************/

#include <stdio.h>
#include <math.h>

#define DEFINE_DATA
#include "nghds.h"

int main (int argc, char **argv)
{ 
  int j = 0;   /* counter */

  /* Following variables are used in reading the pedigree data */
  int dodo_dim; 
  int **dodo = NULL; 
  double **quant = NULL;

  int nfou;                      /* Number of founders */

  int prob_id;                      /* The proband */
  int mum_id = 0;
  int dad_id = 0;
  int prob_index; 

  /* Sequence of recombination fractions between the two loci */
  double rset[] = {0.0, 0.01, 0.04, 0.05, 0.1, 0.18, 0.3, 0.5};
  /* IBD probabilities at those RFs. */
  double g4set[10];

  FILE *fopen(), *fp;

  print_head("autolink");

  MaxNames = MAX_NAMES;
  NColData = 7;
  MaxNCmps = 10;

  if (argc != 2) {
    printf("Usage: autolink input_file\n");
  }  
  
  /* Open data file */
  if ((fp = fopen(argv[1], "r")) == NULL) {
    fprintf(stderr,"Can't open the data file.\n");
    perror((char *) NULL);
    exit(1); 
  }
  /* Read in data */
  fscanf (fp, "%d %d", &PedSize, &dodo_dim);    /* i and nt should be 0 */
  fscanf (fp, "%d %d", &NInts,   &NTraits );
  printf ("\n pedsize =%d", PedSize);
  printf ("\n and ints and floats = %d %d \n", NInts, NTraits);
  fflush(stdout);

  for (j = 0; j < NInts; ++j) {
    SelInt[j] = j + 1;
  }
  alloc_ped();
  input_ped(fp, 0, dodo, quant);
  
  nfou = count_founders();  
  printf ("\n # founders = %d", nfou);
  printf ("\n # components = %d", n_compnts);

  /* The proband */
  fscanf (fp, "%d", &prob_id);

  /* close data file */
  fclose (fp);
  
  prob_index = posit[prob_id][0];
  
  mum_id = nghd[prob_index].ma->self; 
  dad_id = nghd[prob_index].pa->self;


  for (j = 0; j <= 7; ++j)  {  
    g4set[j]= g4link(mum_id, dad_id, mum_id, dad_id, 
		     prob_id, prob_id, prob_id, prob_id,
		     rset[j]);
    printf ("\n\n For r= %f we have g4link =  ", rset[j]);
    fflush(stdout);
    printf ("  %f", g4set[j]); 
  }
  
  printf("\n");
  
  return 0;
}
