   
#include "stuff.h"

static time_t start_tim;             /*start time for program execution*/
 
/* ---------- print_head:  prints header at start of output ----------- */

void print_head(char *program)
{
    time(&start_tim);
    printf("\n %s - %s", MORGVERS, program);
    printf("               %s\n\n", ctime(&start_tim));
    fflush(stdout);
}

/* ----------- print_tail:  prints trailer at end of output -----------	 */

void print_tail(void)
{
    time_t end_time;
    int hr, min, sec;
    struct tms buffer;
    double elapsd_time;
    double ticks_per_sec = sysconf(_SC_CLK_TCK);

    char *hostname = malloc(MAXHOSTNAMELEN * sizeof(char));
    alloc_chk(WHERE, hostname);

    gethostname(hostname, MAXHOSTNAMELEN);
    printf("\n     hostname:  %s\n\n", hostname);
    free(hostname);
    hostname = NULL;

    hr = min = sec = 0;
    time(&end_time);
    elapsd_time = difftime(end_time, start_tim);

    hr = elapsd_time / 3600;

    if (elapsd_time >= 3600 * hr)
	elapsd_time -= 3600 * hr;

    min = elapsd_time / 60;

    if (elapsd_time >= 60 * min)
	elapsd_time -= 60 * min;

    sec = elapsd_time;

    times(&buffer);
    printf("  system time:  %.3f sec\n", buffer.tms_stime / ticks_per_sec);
    printf("    user time:  %.3f sec\n", buffer.tms_utime / ticks_per_sec);

    printf(" elapsed time:  %d hr %d min %d sec\n\n", hr, min, sec);
    fflush(stdout);

    fflush(stderr);
}
